# Build and test firmware

## Kasli standalone

### Checklist

1. Build firmware (see commands below)
2. Flash firmware and settings
3. Test hardware
4. Create a flash-drive with `device_db.py` file for customers (FAT32)

### CLI commands

```shell
mkdir <variant>
cd <variant>/
git clone git@github.com:m-labs/artiq.git
cd artiq/
git checkout origin/release-7
nix develop
artiq_mkfs -s ip 192.168.1.75 kasli.config
artiq_flash storage -f kasli.config
artiq_ddb_template -o device_db.py <variant>.json 
python -m artiq.gateware.targets.kasli_generic <variant>.json 
artiq_flash --srcbuild -d artiq_kasli/<variant>/
artiq_sinara_tester
```

Follow `artiq_sinara_tester` instructions for testing the hardware. For more detailed information, 
you can use this book's pages, or if there is no instruction for testing your hardware, please add them to this book.